// Mobile Traiding Terminal
import java.io.*;
import java.lang.*;
import javax.microedition.io.*;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import javax.microedition.rms.*;

public class MTT
             extends MIDlet
             implements CommandListener{

  private Display    mDisplay;
  private Form       mMainForm,
                     periodScreen,
                     instrumentScreen,
                     helpScreen;
  private StringItem mMessageItem;
  private Command    mExitCommand, 
                     mConnectCommand, 
                     mMenuCommand, 
                     cExitCommand,
                     fExitCommand,
                     hExitCommand,
                     hGoCommand,
                     iExitCommand,
                     iGoCommand,
                     pExitCommand,
                     pGoCommand,
                     oExitCommand,
                     oGoCommand,
                     coExitCommand,
                     coCreateCommand,
                     roExitCommand,
                     roGoCommand,
                     chExitCommand,
                     chGoCommand;
  private ChoiceGroup MTTChoice,
                     instrumentChoice,
                     periodChoice,
                     OrdersChoice,
                     OrdersToRemoveChoice,
                     OrderTypeChoice;
  public String      buffer_size = "8192";
  String             s,
                     NameOfInstrument,  
                     NameOfPeriod,         
                     DataInMessage, 
                     ICMessage,
                     protocol = "socket://";
  Candles            candles;
  private TextField  InputURL = null,
                     InputInstrument = null, 
                     InputRate = null,
                     InputAmount = null,
                     InputSlippage = null,
                     InputComment = null,
                     InputMagic = null,
                     InputColor = null,
                     InputLimitRate = null,
                     InputStopRate = null,
                     InputNumberOfOrderToRemove = null,
                     InputNumberOfOrderToChange = null,
                     InputNewPrice,
                     InputNewStopLoss,
                     InputNewTakeProfit,
                     InputRefreshInterval = null;
  protected volatile RecordStore recordStore = null;
  private Thread     t;
  private boolean    httpCF = false;
  public CM          cm;
  RG                 rg;

  public MTT() {
    try{
      cm = new CM();
      mMainForm = new Form("Mobile Trading Terminal");
      mMessageItem = new StringItem(null, "");
      fExitCommand = new Command("Back",Command.EXIT,0); 
      mExitCommand = new Command("Exit", Command.EXIT, 0);
      mConnectCommand = new Command("Connect",Command.SCREEN, 0);
      InputURL = 
          new TextField("URL:",ReadWriteRecordStore(3, " ", false), 38, TextField.ANY);
      InputRefreshInterval = 
          new TextField("Refresh Interval:", ReadWriteRecordStore(4, " ", false), 13, TextField.NUMERIC);
      mMainForm.append(InputURL);
      mMainForm.append(InputRefreshInterval);
      mMainForm.append(mMessageItem);
      mMainForm.addCommand(mExitCommand);
      mMainForm.addCommand(mConnectCommand);
      mMainForm.setCommandListener(this);
    }catch (Exception e){
       MD("MTT :: " + e.toString());
    }
  }

  public void startApp() {
    try{
      mDisplay = Display.getDisplay(this);
      mDisplay.setCurrent(mMainForm);
    }catch (Exception e){
       MD("startApp :: " + e.toString());
    }
  }

  public void pauseApp() {
    try{
    }catch (Exception e){
       MD("pauseApp :: " + e.toString());
    }
  }

  public void destroyApp(boolean unconditional) {
    try{
    }catch (Exception e){
       MD("destroyApp :: " + e.toString());
    }
  }

  public void commandAction(final Command c, Displayable s) {
    try{
      t = new Thread(){
        public void run(){
          if (c == mMenuCommand   ) showHelp();  
          if (c == cExitCommand   ) notifyDestroyed();
          if (c == hGoCommand     ) SelectedForm();    
          if (c == iGoCommand     ) SelectPeriod();
          if (c == pGoCommand     ) SelectInstrument();
          if (c == oGoCommand     ) Orders();
          if (c == coCreateCommand) subSendOrder();
          if (c == roGoCommand    ) subSendRemoveOrder();
          if (c == chGoCommand    ) subSendChangeOrder();
          if (c == mConnectCommand) subLogin();
          if((c == mExitCommand   ) ||
             (c == hExitCommand   ) ||
             (c == oExitCommand   ) ||
             (c == iExitCommand   ) ||
             (c == pExitCommand   ) ||
             (c == coExitCommand  ) ||
             (c == fExitCommand   ) ||
             (c == roExitCommand  ) ||                   
             (c == chExitCommand  )){
               System.gc();
               showCandles(connect("gD",true), false);
          }
        }
      };
      t.start();
    }catch(Exception e){
       MD("commandAction :: " + e.toString());
    }  
  }

  private String connect(String parameters,boolean waittrue) {
    String Back = new String();
    Back = null;
    System.gc();
    try{
      String url = protocol + InputURL.getString();
      Back = cm.entrance(parameters,url,waittrue,mDisplay);
      ReadWriteRecordStore(3, InputURL.getString(), true);
      ReadWriteRecordStore(4, InputRefreshInterval.getString(), true);
      System.gc();
    }catch(Exception e){
       MD(e.toString() + " :: connect"); 
    }      
    if (waittrue == true) return (Back);
    else return("nothing");
  }

  private void MD(String md){
    //Alert a = new Alert("we here MD",md, null, AlertType.ERROR);
    //a.setTimeout(Alert.FOREVER);
    //mDisplay.setCurrent(a);
     mMessageItem.setText(md);
     mMainForm.setCommandListener(this);
     mDisplay.vibrate(100);
  }

  public String ReadWriteRecordStore(int index, String data, boolean RW){
    String IID = "EURUSD";
    String PID = "240";
    String URL = "192.168.0.1:36895";
    String RI  = "31";
    try{
      recordStore = RecordStore.openRecordStore("IIDRecordStore", true);
      if (recordStore.getNumRecords() !=0){
        if (RW == false){
          String rD = new String(recordStore.getRecord(index));
          return(rD);
        }else{
          recordStore.setRecord(index,
                                data.getBytes(),
                                0,
                                data.getBytes().length);
          return("Written");
        }
      }else{
        try{
          recordStore.addRecord(IID.getBytes(), 
                                0,
                                IID.getBytes().length );
          recordStore.addRecord(PID.getBytes(),
                                0,
                                PID.getBytes().length );
          recordStore.addRecord(URL.getBytes(),
                                0,
                                URL.getBytes().length );
          recordStore.addRecord(RI.getBytes(),
                                0,
                                RI.getBytes().length );
          if (index == 1) return(IID);
          if (index == 2) return(PID);
          if (index == 3) return(URL);
          if (index == 4) return(RI);
        }
        catch (RecordStoreNotOpenException rsnoe){
          MD("ReadWriteRecordStore :: " + rsnoe.toString());
        }
      }  
    }
    catch (Exception e){
      MD("ReadWriteRecordStore :: " + e.toString());
    }    
    return("good");
  }

  public void showCandles(String in, boolean or) {        
    String mistakeCatcher = new String();
    String response = new String();
    StringBuffer tString = new StringBuffer("Mobile Trading Terminal (in conjunction with Meta Trader 4.0)");
    try{
      String IID = ReadWriteRecordStore(1, " ", false);
      String PID = ReadWriteRecordStore(2, " ", false); 
      if (or == true){
        System.gc();
        candles = new Candles (mDisplay, tString);
        mMenuCommand = new Command("Menu", Command.HELP, 0);
        cExitCommand = new Command("Exit", Command.EXIT, 0);
        candles.addCommand(cExitCommand);
        candles.addCommand(mMenuCommand); 
        Ticker ticker = new Ticker(tString.toString());
        candles.setTicker(ticker);
        response = candles.start(in,true, IID, PID); 
        mDisplay.setCurrent(candles);
        candles.setCommandListener(this);
      }else {
        candles.start(in, or, IID, PID);
        mDisplay.setCurrent(candles);
        candles.setCommandListener(this);
      }
      if (httpCF == false){
        rg = new RG(mDisplay,candles,cm, 
             protocol + InputURL.getString(),true,
             InputRefreshInterval.getString());
        httpCF = true;
      }
    }catch (Exception e){
       MD("sC::" + e.toString() + "::" + in + "::" + mistakeCatcher+ "::" +response);
    }
  }
  void showHelp() {
    try{
      MTTChoice = new ChoiceGroup("MTT menu", Choice.EXCLUSIVE); 
      helpScreen = new Form("MTT Menu");
      hExitCommand = new Command("Back", Command.BACK, 0);
      hGoCommand = new Command("Go", Command.OK,0);
      helpScreen.addCommand(hExitCommand);
      helpScreen.addCommand(hGoCommand); 
      MTTChoice.append("Tools",null);
      MTTChoice.append("Orders",null);
      helpScreen.append(MTTChoice);
      mDisplay.setCurrent(helpScreen);
      helpScreen.setCommandListener(this);
    }catch (Exception e){
      MD("showHelp :: " + e.toString());
    }
  } 
  void SelectedForm() {
    try{
      int ChoiceResult = MTTChoice.getSelectedIndex();
      if (ChoiceResult == 0) subInstruments();
      if (ChoiceResult == 1) subOrders();
    }catch (Exception e){
      MD("SelectedForm :: " + e.toString());
    }    
  }
  void subInstruments(){
    try{
      instrumentChoice = new ChoiceGroup("Instruments", Choice.EXCLUSIVE);
      instrumentScreen = new Form("Instruments");
      iExitCommand = new Command("BACK", Command.BACK,0);
      iGoCommand = new Command("GO", Command.OK,0);
      instrumentScreen.addCommand(iExitCommand);
      instrumentScreen.addCommand(iGoCommand);
      instrumentChoice.append("eur/usd",null);
      instrumentChoice.append("usd/jpy",null);
      instrumentChoice.append("gbp/usd",null);
      instrumentChoice.append("usd/chf",null);
      instrumentChoice.append("eur/chf",null);
      instrumentChoice.append("eur/jpy",null);
      instrumentChoice.append("gbp/jpy",null);
      instrumentChoice.append("eur/gbp",null);
      instrumentChoice.append("usd/cad",null);
      instrumentChoice.append("aud/usd",null);
      instrumentChoice.append("eur/cad",null);
      instrumentChoice.append("eur/aud",null);
      instrumentChoice.append("gbp/chf",null);
      instrumentChoice.append("chf/jpy",null);
      instrumentChoice.append("aud/cad",null);
      instrumentChoice.append("aud/jpy",null);
      instrumentChoice.append("nzd/usd",null);
      instrumentChoice.append("cad/jpy",null);
      instrumentChoice.append("nzd/jpy",null);
      instrumentScreen.append(instrumentChoice);
      mDisplay.setCurrent(instrumentScreen);
      instrumentScreen.setCommandListener(this);
    }catch(Exception e){
      MD("subInstruments :: " + e.toString());
    }
  }
  void SelectPeriod(){
    try{
      periodChoice = new ChoiceGroup("Period", Choice.EXCLUSIVE);
      periodScreen = new Form("Period");
      pExitCommand = new Command("BACK",Command.BACK,0);
      pGoCommand = new Command("GO", Command.OK, 0);
      periodScreen.addCommand(pExitCommand);
      periodScreen.addCommand(pGoCommand);
      periodChoice.append("1_MIN",null);
      periodChoice.append("5_MIN",null);
      periodChoice.append("15_MIN",null);
      periodChoice.append("30_MIN",null);
      periodChoice.append("1_HOUR",null);
      periodChoice.append("4_HOURS",null);
      periodChoice.append("1_DAY",null);
      periodChoice.append("1_WEEK",null);
      periodChoice.append("1_MONTH",null);
      periodScreen.append(periodChoice);
      mDisplay.setCurrent(periodScreen);
      periodScreen.setCommandListener(this);
    }catch(Exception e){
      MD("SelectPeriod :: " + e.toString());
    }  
  }
  void SelectInstrument(){
    try{
      int ChoiceResult = instrumentChoice.getSelectedIndex();
      if (ChoiceResult == 0)NameOfInstrument = "EURUSD"; // "eur/usd";
      if (ChoiceResult == 1)NameOfInstrument = "USDJPY"; // "usd/jpy";
      if (ChoiceResult == 2)NameOfInstrument = "GBPUSD"; // "gbp/usd";
      if (ChoiceResult == 3)NameOfInstrument = "USDCHF"; // "usd/chf";
      if (ChoiceResult == 4)NameOfInstrument = "EURCHF"; // "eur/chf";
      if (ChoiceResult == 5)NameOfInstrument = "EURJPY"; // "eur/jpy";
      if (ChoiceResult == 6)NameOfInstrument = "GBPJPY"; // "gbp/jpy";
      if (ChoiceResult == 7)NameOfInstrument = "EURGBP"; // "eur/gbp";
      if (ChoiceResult == 8)NameOfInstrument = "USDCAD"; // "usd/cad";
      if (ChoiceResult == 9)NameOfInstrument = "AUDUSD"; // "aud/usd";
      if (ChoiceResult == 10)NameOfInstrument = "EURCAD"; // "eur/cad";
      if (ChoiceResult == 11)NameOfInstrument = "EURAUD"; // "eur/aud";
      if (ChoiceResult == 12)NameOfInstrument = "GBPCHF"; // "gbp/chf";
      if (ChoiceResult == 13)NameOfInstrument = "CHFJPY"; // "chf/jpy";
      if (ChoiceResult == 14)NameOfInstrument = "AUDCAD"; // "aud/cad";
      if (ChoiceResult == 15)NameOfInstrument = "AUDJPY"; // "aud/jpy";
      if (ChoiceResult == 16)NameOfInstrument = "NZDUSD"; // "nzd/usd";
      if (ChoiceResult == 17)NameOfInstrument = "CADJPY"; // "cad/jpy";
      if (ChoiceResult == 18)NameOfInstrument = "NZDJPY"; // "nzd/jpy";
      ChoiceResult = periodChoice.getSelectedIndex();
      if (ChoiceResult == 0)NameOfPeriod = "1";
      if (ChoiceResult == 1)NameOfPeriod = "5";
      if (ChoiceResult == 2)NameOfPeriod = "15";
      if (ChoiceResult == 3)NameOfPeriod = "30";
      if (ChoiceResult == 4)NameOfPeriod = "60";
      if (ChoiceResult == 5)NameOfPeriod = "240";
      if (ChoiceResult == 6)NameOfPeriod = "1440";
      if (ChoiceResult == 7)NameOfPeriod = "10080";
      if (ChoiceResult == 8)NameOfPeriod = "43200";
      String back = ReadWriteRecordStore(1, NameOfInstrument, true);
      back = ReadWriteRecordStore(2, NameOfPeriod, true);
      history(true);
    }catch(Exception e){
      MD("SelectInstrument :: " + e.toString());
    }
  }

  void subOrders(){
    try{
      OrdersChoice = new ChoiceGroup("Order menu", Choice.EXCLUSIVE); 
      Form OrdersForm = new Form ("Orders");
      oExitCommand = new Command("Back", Command.BACK, 0);
      oGoCommand = new Command("Go", Command.OK,0);
      OrdersForm.addCommand(oExitCommand);
      OrdersForm.addCommand(oGoCommand);
      OrdersChoice.append("Create Order",null);
      OrdersChoice.append("Remove Order",null);
      OrdersChoice.append("Change Order",null);
      OrdersForm.append(OrdersChoice);
      mDisplay.setCurrent(OrdersForm);
      OrdersForm.setCommandListener(this);
    }catch(Exception e){
       MD("subOrders :: " + e.toString());
    }
  }
  void Orders(){
    try{
      int ChoiceResult = OrdersChoice.getSelectedIndex();
      if (ChoiceResult == 0) CreateOrder();
      if (ChoiceResult == 1) RemoveOrder();
      if (ChoiceResult == 2) ChangeOrder();
    }catch(Exception e){
       MD("Orders :: " + e.toString());
    }
  }
  void subSendChangeOrder(){
    String OrderModify = connect("OrderModify(" + 
      InputNumberOfOrderToChange.getString() + "," + 
      InputNewPrice.getString() + "," +
      InputNewStopLoss.getString() + "," +
      InputNewTakeProfit.getString() + ")",true);
      showCandles(OrderModify, false);
  }
  void ChangeOrder(){
    try{
      String orders = connect("get_Orders()",true);
      StringItem oMessageItem = new StringItem
        ("Choose Order To Change:" + '\r' + '\n', orders);
      Form ChangeForm = new Form("Change Order");
      InputNumberOfOrderToChange = 
        new TextField("Order To Change: ","0",13,TextField.ANY);
      InputNewPrice= 
        new TextField("New Price: ","0.0",13,TextField.DECIMAL);
      InputNewStopLoss= 
        new TextField("New Stop Loss: ","0.0",13,TextField.DECIMAL);
      InputNewTakeProfit= 
        new TextField("New Take Profit: ","0.0",13,TextField.DECIMAL);
      ChangeForm.append(oMessageItem);
      ChangeForm.append(InputNumberOfOrderToChange);
      ChangeForm.append(InputNewPrice);
      ChangeForm.append(InputNewStopLoss);
      ChangeForm.append(InputNewTakeProfit);
      chExitCommand = new Command("Back",Command.BACK,0);
      chGoCommand = new Command("Go",Command.OK,0);
      ChangeForm.addCommand(chExitCommand);        
      ChangeForm.addCommand(chGoCommand);
      mDisplay.setCurrent(ChangeForm);
      ChangeForm.setCommandListener(this);
    }catch(Exception e){
       MD("ChangeOrder :: " + e.toString());
    }
  }
  void RemoveOrder(){
    try{
      String orders = connect("get_Orders()",true);
      StringItem oMessageItem = new StringItem
        ("Choose Order To Remove:" + '\r' + '\n', orders);
      Form RemoveOrder = new Form("Remove Order");   
      InputNumberOfOrderToRemove = 
        new TextField("Order To Remove: ","0",13,TextField.ANY);
      RemoveOrder.append(InputNumberOfOrderToRemove);
      RemoveOrder.append(oMessageItem); 
      roExitCommand = new Command("Back",Command.BACK,0);
      roGoCommand = new Command("Go",Command.OK,0);
      RemoveOrder.addCommand(roExitCommand);
      RemoveOrder.addCommand(roGoCommand);
      mDisplay.setCurrent(RemoveOrder);
      RemoveOrder.setCommandListener(this);
    }catch(Exception e){
       MD("RemoveOrder :: " + e.toString());
    }
  }
  void subSendRemoveOrder(){
    try{
      String orderToRemove = connect("remove_Order(" +    
        InputNumberOfOrderToRemove.getString() + ")",true);
      showCandles(orderToRemove, false);
    }catch(Exception e){
       MD("subSendRemoveOrder :: " + e.toString());
    }
  }
  void CreateOrder(){
    try{
      Form OrderForm = new Form("Create Order");
      InputInstrument  = 
        new TextField("Symbol: ",
        ReadWriteRecordStore(1, " ", false),13,TextField.ANY);
      OrderTypeChoice = new ChoiceGroup("Order type menu", Choice.EXCLUSIVE);
      OrderTypeChoice.append("BUY",null);
      OrderTypeChoice.append("SELL",null);
      OrderTypeChoice.append("BUYLIMIT",null);
      OrderTypeChoice.append("SELLLIMIT",null);
      OrderTypeChoice.append("BUYSTOP",null);
      OrderTypeChoice.append("SELLSTOP",null);
      InputAmount  = 
        new TextField("Volume: ","0.1",13,TextField.DECIMAL);
      float bid = candles.bid;
      InputRate   = 
        new TextField("Price: ",Float.toString(bid),13,TextField.DECIMAL);
      InputSlippage = 
        new TextField("Slippage: ","0",13,TextField.NUMERIC);
      InputStopRate = 
        new TextField("Stop loss: ",Float.toString(bid),13,TextField.DECIMAL);
      InputLimitRate = 
        new TextField("Take profit: ","0.0",13,TextField.DECIMAL);
      InputComment = 
        new TextField("Comment: ","MTT order",13,TextField.ANY);
      InputMagic  = 
        new TextField("Magic number: ","777",13,TextField.NUMERIC);
      OrderForm.append(InputInstrument);
      OrderForm.append(OrderTypeChoice);
      OrderForm.append(InputAmount);
      OrderForm.append(InputRate);
      OrderForm.append(InputSlippage);
      OrderForm.append(InputStopRate);
      OrderForm.append(InputLimitRate);
      OrderForm.append(InputComment);
      OrderForm.append(InputMagic);
      coExitCommand = new Command("Back",Command.EXIT,0); 
      coCreateCommand = new Command("Create",Command.OK, 0);
      OrderForm.addCommand(coExitCommand);
      OrderForm.addCommand(coCreateCommand);  
      mDisplay.setCurrent(OrderForm);
      OrderForm.setCommandListener(this);
    }catch(Exception e){
       MD("CreateOrder :: " + e.toString());
    }
  }
  void subSendOrder(){
    try{
      String parameters = "OrderSend(" +  
        InputInstrument.getString() + "," +
        Integer.toString(OrderTypeChoice.getSelectedIndex()) + "," +
        InputAmount.getString() + "," +
        InputRate.getString() + "," +
        InputSlippage.getString() + "," +
        InputStopRate.getString() + "," +
        InputLimitRate.getString() + "," +
        InputComment.getString() + "," +
        InputMagic.getString() + ")";// +
      String responseMessage = connect(parameters,true);
      showCandles(responseMessage, false);
    }catch(Exception e){
       MD("subSendOrder :: " + e.toString());
    }     
  }
  void history(boolean pnp){
    try{
      System.gc();
      String responseMessage = new String();
      String IID = ReadWriteRecordStore(1, " ", false);
      String PID = ReadWriteRecordStore(2, " ", false);
      String history = "GetHistory(" + IID +"," + PID +"," + "true,77)";
      responseMessage = connect(history,true);
      showCandles(responseMessage,pnp);
    }catch(Exception e){
       MD("history :: " + e.toString());
    }
  }
  void subLogin(){
    try{
      history(true);
    }catch(Exception e){
       MD("subLogin :: " + e.toString());
    }
  }
}
